<?php
// +---------------------------------------------------------------+
// | phpWebGallery block - shows a random image                    |
// | Copyright (c) 2005 Albert Hernandez - tux@fractaloon.com      |
// +---------------------------------------------------------------+
// | last update  : 2005-July-3                                    |
// +---------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or |
// | and/or modify it under the terms of the GNU General Public    |
// | License as published by the Free Software Foundation          |
// |                                                               |
// | This program is distributed in the hope that it will be       |
// | useful, but WITHOUT ANY WARRANTY; without even the implied    |
// | warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR       |
// | PURPOSE.  See the GNU General Public License for more         |
// | details.                                                      |
// |                                                               |
// | You should have received a copy of the GNU General Public     |
// | License along with this program; if not, write the Free       |
// | Software Foundation, Inc., 59 Temple Place - Suite 330,       |
// | Boston, MA 02111-1307, USA                                    |
// +---------------------------------------------------------------+

// Enter the path to your mysql.inc.php from phpWebGallery.  It's
//  something like /var/www/phpWebGallery/include/mysql.inc.php
include ('/path/to/mysql.inc.php');
// Enter the URL for your phgWebGallery photo album here.
$_PhotoPath = 'http://www.myURL.com/phpWebGallery';

// This function will select a random image and display the thumbnail in a block.
function phpblock_showimage() {
    global $cfgHote, $cfgBase, $cfgUser, $cfgPassword, $prefixeTable, $_PhotoPath;

    // This is the SQL to select one random picture.
    $img_sql = 'SELECT * FROM ' . $prefixeTable . 'images ORDER BY rand() limit 1';
    // Connect to the database.
    $_PhotoDB = new database($cfgHote, $cfgBase, $cfgUser, $cfgPassword, 'COM_errorLog');

    // Return a recordset with one image
    $_PhotoRS = $_PhotoDB->dbQuery($img_sql, $ignore_errors);

    // Get the path for the thumbnail.
    $_imgFull = substr($_PhotoDB->dbResult($_PhotoRS, 0, 'path'), 1);
    $_imgFName = $_PhotoDB->dbResult($_PhotoRS, 0, 'file');
    $_imgExt = $_PhotoDB->dbResult($_PhotoRS, 0, 'tn_ext');
    $_imgPrefix = PWG_GetConfig($_PhotoDB, 'prefix_thumbnail');

    $_imgFull = str_replace($_imgFName, 'thumbnail/' . $_imgPrefix . $_imgFName, $_imgFull);
    $_imgFull = substr($_imgFull, 0, strlen($_imgFull) - strlen($_imgExt)) . $_imgExt;
    $_imgFull = $_PhotoPath . $_imgFull;

    // Create the path for a link.
    $_imgCategory = $_PhotoDB->dbResult($_PhotoRS, 0, 'storage_category_id');
    $_imgID = $_PhotoDB->dbResult($_PhotoRS, 0, 'id');

    $PhotoLink= $_PhotoPath . '/picture.php?cat=' . $_imgCategory . '&image_id=' . $_imgID;

    // Get the name & comment of the image.
    $_imgName = $_PhotoDB->dbResult($_PhotoRS, 0, 'name');
    if (strlen($_imgName)==0) {
        $_imgName = substr($_imgFName, 0, strrpos($_imgFName, '.'));
    }
    $_imgComment = $_PhotoDB->dbResult($_PhotoRS, 0, 'comment');

    // Display the image
    $result = '<center><a href="' . $PhotoLink . '">' .
        '<img src="' . $_imgFull . '"><br>' .
        $_imgName . '</a><br>' . $_imgComment . '</center>';
    return $result;
}

// Return a parameter value from the photo album database.
function PWG_GetConfig($_PhotoDB, $cfgParam) {
    global $prefixeTable;

    $cfg_sql = 'SELECT value FROM ' . $prefixeTable . 'config WHERE param="' . $cfgParam . '"';
    $_ConfigRS = $_PhotoDB->dbQuery($cfg_sql, $ignore_errors);

    return $_PhotoDB->dbResult($_ConfigRS, 0, 'value');
}
?>
